commit 732a4657e2ba4a3bd5b4244e06cfbae9bb2a3e56
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Mon Feb 25 13:42:39 2019 +0100

    ChibiOS updated to version stable_19.1.x.
    NOTE: ChibiOS 19.1.x seems to contain some issues as of now.

diff --git a/modules/aos_chconf.h b/modules/aos_chconf.h
index 166c681..055f2d4 100644
--- a/modules/aos_chconf.h
+++ b/modules/aos_chconf.h
@@ -30,7 +30,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #define AOS_CHCONF_H
 
 #define _CHIBIOS_RT_CONF_
-#define _CHIBIOS_RT_CONF_VER_5_1_
+#define _CHIBIOS_RT_CONF_VER_6_0_
 
 /*===========================================================================*/
 /**
@@ -97,7 +97,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @note    The round robin preemption is not supported in tickless mode and
  *          must be set to zero in that case.
  */
+#if !defined(CH_CFG_TIME_QUANTUM)
 #define CH_CFG_TIME_QUANTUM                 0
+#endif
 
 /**
  * @brief   Managed RAM size.
@@ -110,7 +112,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *          provide the @p __heap_base__ and @p __heap_end__ symbols.
  * @note    Requires @p CH_CFG_USE_MEMCORE.
  */
+#if !defined(CH_CFG_MEMCORE_SIZE)
 #define CH_CFG_MEMCORE_SIZE                 0
+#endif
 
 /**
  * @brief   Idle thread automatic spawn suppression.
@@ -119,7 +123,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *          function becomes the idle thread and must implement an
  *          infinite loop.
  */
+#if !defined(CH_CFG_NO_IDLE_THREAD)
 #define CH_CFG_NO_IDLE_THREAD               FALSE
+#endif
 
 /** @} */
 
@@ -138,7 +144,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @note    This is not related to the compiler optimization options.
  * @note    The default is @p TRUE.
  */
+#if !defined(CH_CFG_OPTIMIZE_SPEED)
 #define CH_CFG_OPTIMIZE_SPEED               TRUE
+#endif
 
 /** @} */
 
@@ -156,7 +164,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *
  * @note    The default is @p TRUE.
  */
+#if !defined(CH_CFG_USE_TM)
 #define CH_CFG_USE_TM                       TRUE
+#endif
 
 /**
  * @brief   Threads registry APIs.
@@ -164,7 +174,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *
  * @note    The default is @p TRUE.
  */
+#if !defined(CH_CFG_USE_REGISTRY)
 #define CH_CFG_USE_REGISTRY                 FALSE
+#endif
 
 /**
  * @brief   Thread hierarchy APIs.
@@ -172,14 +184,18 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *
  * @note    The default is @p FALSE.
  */
+#if !defined(CH_CFG_USE_THREADHIERARCHY)
 #define CH_CFG_USE_THREADHIERARCHY          TRUE
+#endif
 
 /**
  * @brief   Enable ordering of child lists.
  * @details Children will be ordered by their priority (descending).
  *          If sibliblings have identical priority, they are ordered by age (descending).
  */
+#if !defined(CH_CFG_THREADHIERARCHY_ORDERED)
 #define CH_CFG_THREADHIERARCHY_ORDERED      TRUE
+#endif
 
 /**
  * @brief   Threads synchronization APIs.
@@ -188,7 +204,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *
  * @note    The default is @p TRUE.
  */
+#if !defined(CH_CFG_USE_WAITEXIT)
 #define CH_CFG_USE_WAITEXIT                 TRUE
+#endif
 
 /**
  * @brief   Semaphores APIs.
@@ -196,7 +214,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *
  * @note    The default is @p TRUE.
  */
+#if !defined(CH_CFG_USE_SEMAPHORES)
 #define CH_CFG_USE_SEMAPHORES               TRUE
+#endif
 
 /**
  * @brief   Semaphores queuing mode.
@@ -207,7 +227,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *          requirements.
  * @note    Requires @p CH_CFG_USE_SEMAPHORES.
  */
+#if !defined(CH_CFG_USE_SEMAPHORES_PRIORITY)
 #define CH_CFG_USE_SEMAPHORES_PRIORITY      FALSE
+#endif
 
 /**
  * @brief   Mutexes APIs.
@@ -215,7 +237,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *
  * @note    The default is @p TRUE.
  */
+#if !defined(CH_CFG_USE_MUTEXES)
 #define CH_CFG_USE_MUTEXES                  TRUE
+#endif
 
 /**
  * @brief   Enables recursive behavior on mutexes.
@@ -225,7 +249,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @note    The default is @p FALSE.
  * @note    Requires @p CH_CFG_USE_MUTEXES.
  */
+#if !defined(CH_CFG_USE_MUTEXES_RECURSIVE)
 #define CH_CFG_USE_MUTEXES_RECURSIVE        FALSE
+#endif
 
 /**
  * @brief   Conditional Variables APIs.
@@ -235,7 +261,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @note    The default is @p TRUE.
  * @note    Requires @p CH_CFG_USE_MUTEXES.
  */
+#if !defined(CH_CFG_USE_CONDVARS)
 #define CH_CFG_USE_CONDVARS                 TRUE
+#endif
 
 /**
  * @brief   Conditional Variables APIs with timeout.
@@ -245,7 +273,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @note    The default is @p TRUE.
  * @note    Requires @p CH_CFG_USE_CONDVARS.
  */
+#if !defined(CH_CFG_USE_CONDVARS_TIMEOUT)
 #define CH_CFG_USE_CONDVARS_TIMEOUT         TRUE
+#endif
 
 /**
  * @brief   Events Flags APIs.
@@ -253,7 +283,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *
  * @note    The default is @p TRUE.
  */
+#if !defined(CH_CFG_USE_EVENTS)
 #define CH_CFG_USE_EVENTS                   TRUE
+#endif
 
 /**
  * @brief   Events Flags APIs with timeout.
@@ -263,7 +295,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @note    The default is @p TRUE.
  * @note    Requires @p CH_CFG_USE_EVENTS.
  */
+#if !defined(CH_CFG_USE_EVENTS_TIMEOUT)
 #define CH_CFG_USE_EVENTS_TIMEOUT           TRUE
+#endif
 
 /**
  * @brief   Synchronous Messages APIs.
@@ -272,7 +306,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *
  * @note    The default is @p TRUE.
  */
+#if !defined(CH_CFG_USE_MESSAGES)
 #define CH_CFG_USE_MESSAGES                 FALSE
+#endif
 
 /**
  * @brief   Synchronous Messages queuing mode.
@@ -283,7 +319,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *          requirements.
  * @note    Requires @p CH_CFG_USE_MESSAGES.
  */
+#if !defined(CH_CFG_USE_MESSAGES_PRIORITY)
 #define CH_CFG_USE_MESSAGES_PRIORITY        FALSE
+#endif
 
 /**
  * @brief   Mailboxes APIs.
@@ -293,7 +331,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @note    The default is @p TRUE.
  * @note    Requires @p CH_CFG_USE_SEMAPHORES.
  */
+#if !defined(CH_CFG_USE_MAILBOXES)
 #define CH_CFG_USE_MAILBOXES                FALSE
+#endif
 
 /**
  * @brief   Core Memory Manager APIs.
@@ -302,7 +342,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *
  * @note    The default is @p TRUE.
  */
+#if !defined(CH_CFG_USE_MEMCORE)
 #define CH_CFG_USE_MEMCORE                  FALSE
+#endif
 
 /**
  * @brief   Heap Allocator APIs.
@@ -314,7 +356,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *          @p CH_CFG_USE_SEMAPHORES.
  * @note    Mutexes are recommended.
  */
+#if !defined(CH_CFG_USE_HEAP)
 #define CH_CFG_USE_HEAP                     FALSE
+#endif
 
 /**
  * @brief   Memory Pools Allocator APIs.
@@ -323,16 +367,31 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *
  * @note    The default is @p TRUE.
  */
+#if !defined(CH_CFG_USE_MEMPOOLS)
 #define CH_CFG_USE_MEMPOOLS                 FALSE
+#endif
 
 /**
- * @brief  Objects FIFOs APIs.
+ * @brief   Objects FIFOs APIs.
  * @details If enabled then the objects FIFOs APIs are included
  *          in the kernel.
  *
  * @note    The default is @p TRUE.
  */
+#if !defined(CH_CFG_USE_OBJ_FIFOS)
 #define CH_CFG_USE_OBJ_FIFOS                FALSE
+#endif
+
+/**
+ * @brief   Pipes APIs.
+ * @details If enabled then the pipes APIs are included
+ *          in the kernel.
+ *
+ * @note    The default is @p TRUE.
+ */
+#if !defined(CH_CFG_USE_PIPES)
+#define CH_CFG_USE_PIPES                    FALSE
+#endif
 
 /**
  * @brief   Dynamic Threads APIs.
@@ -343,7 +402,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @note    Requires @p CH_CFG_USE_WAITEXIT.
  * @note    Requires @p CH_CFG_USE_HEAP and/or @p CH_CFG_USE_MEMPOOLS.
  */
+#if !defined(CH_CFG_USE_DYNAMIC)
 #define CH_CFG_USE_DYNAMIC                  FALSE
+#endif
 
 /** @} */
 
@@ -409,6 +470,13 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #define CH_CFG_FACTORY_OBJ_FIFOS            TRUE
 #endif
 
+/**
+ * @brief   Enables factory for Pipes.
+ */
+#if !defined(CH_CFG_FACTORY_PIPES) || defined(__DOXYGEN__)
+#define CH_CFG_FACTORY_PIPES                TRUE
+#endif
+
 /** @} */
 
 /*===========================================================================*/
@@ -423,11 +491,13 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *
  * @note    The default is @p FALSE.
  */
+#if !defined(CH_DBG_STATISTICS)
 #if ((CH_CFG_USE_TM == TRUE) && (AMIROOS_CFG_DBG == true)) || defined(__DOXYGEN__)
   #define CH_DBG_STATISTICS                 TRUE
 #else
   #define CH_DBG_STATISTICS                 FALSE
 #endif
+#endif
 
 /**
  * @brief   Debug option, system state check.
@@ -436,11 +506,13 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *
  * @note    The default is @p FALSE.
  */
+#if !defined(CH_DBG_SYSTEM_STATE_CHECK)
 #if (AMIROOS_CFG_DBG == true) || defined(__DOXYGEN__)
   #define CH_DBG_SYSTEM_STATE_CHECK         TRUE
 #else
   #define CH_DBG_SYSTEM_STATE_CHECK         FALSE
 #endif
+#endif
 
 /**
  * @brief   Debug option, parameters checks.
@@ -449,11 +521,13 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *
  * @note    The default is @p FALSE.
  */
+#if !defined(CH_DBG_ENABLE_CHECKS)
 #if (AMIROOS_CFG_DBG == true) || defined(__DOXYGEN__)
   #define CH_DBG_ENABLE_CHECKS              TRUE
 #else
   #define CH_DBG_ENABLE_CHECKS              FALSE
 #endif
+#endif
 
 /**
  * @brief   Debug option, consistency checks.
@@ -463,11 +537,13 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *
  * @note    The default is @p FALSE.
  */
+#if !defined(CH_DBG_ENABLE_ASSERTS)
 #if (AMIROOS_CFG_DBG == true) || defined(__DOXYGEN__)
   #define CH_DBG_ENABLE_ASSERTS             TRUE
 #else
   #define CH_DBG_ENABLE_ASSERTS             FALSE
 #endif
+#endif
 
 /**
  * @brief   Debug option, trace buffer.
@@ -475,14 +551,18 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *
  * @note    The default is @p CH_DBG_TRACE_MASK_DISABLED.
  */
+#if !defined(CH_DBG_TRACE_MASK)
 #define CH_DBG_TRACE_MASK                   CH_DBG_TRACE_MASK_DISABLED
+#endif
 
 /**
  * @brief   Trace buffer entries.
  * @note    The trace buffer is only allocated if @p CH_DBG_TRACE_MASK is
  *          different from @p CH_DBG_TRACE_MASK_DISABLED.
  */
+#if !defined(CH_DBG_TRACE_BUFFER_SIZE)
 #define CH_DBG_TRACE_BUFFER_SIZE            128
+#endif
 
 /**
  * @brief   Debug option, stack checks.
@@ -494,11 +574,13 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @note    The default failure mode is to halt the system with the global
  *          @p panic_msg variable set to @p NULL.
  */
+#if !defined(CH_DBG_ENABLE_STACK_CHECK)
 #if (AMIROOS_CFG_DBG == true) || defined(__DOXYGEN__)
   #define CH_DBG_ENABLE_STACK_CHECK         TRUE
 #else
   #define CH_DBG_ENABLE_STACK_CHECK         FALSE
 #endif
+#endif
 
 /**
  * @brief   Debug option, stacks initialization.
@@ -508,11 +590,13 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *
  * @note    The default is @p FALSE.
  */
+#if !defined(CH_DBG_FILL_THREADS)
 #if (AMIROOS_CFG_PROFILE == true) || defined(__DOXYGEN__)
   #define CH_DBG_FILL_THREADS               TRUE
 #else
   #define CH_DBG_FILL_THREADS               FALSE
 #endif
+#endif
 
 /**
  * @brief   Debug option, threads profiling.
@@ -523,11 +607,13 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @note    This debug option is not currently compatible with the
  *          tickless mode.
  */
+#if !defined(CH_DBG_THREADS_PROFILING)
 #if ((CH_CFG_ST_TIMEDELTA == 0) && (AMIROOS_CFG_PROFILE == true)) || defined(__DOXYGEN__)
   #define CH_DBG_THREADS_PROFILING          TRUE
 #else
   #define CH_DBG_THREADS_PROFILING          FALSE
 #endif
+#endif
 
 /** @} */
 
@@ -661,12 +747,15 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 /*===========================================================================*/
 /**
- * @name Port specific settings
+ * @name Port-specific settings (override port settings defaulted in chcore.h).
+ * @{
  */
 /*===========================================================================*/
 
 // These settings are specific to each module.
 
+/** @} */
+
 /*===========================================================================*/
 /**
  * @name other