commit 756ef2f68ba8f3899d220056f88f768694d28307
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Fri Jun 29 10:34:55 2018 +0200

    Added APPS- variables to all source types in the makefiles of all modules

diff --git a/os/modules/DiWheelDrive_1-1/Makefile b/os/modules/DiWheelDrive_1-1/Makefile
index 597e3c2..f178bf0 100644
--- a/os/modules/DiWheelDrive_1-1/Makefile
+++ b/os/modules/DiWheelDrive_1-1/Makefile
@@ -173,28 +173,29 @@ CPPSRC = $(AMIROOSCORECPPSRC) \
 # C sources to be compiled in ARM mode regardless of the global setting.
 # NOTE: Mixing ARM and THUMB mode enables the -mthumb-interwork compiler
 #       option that results in lower performance and larger code size.
-ACSRC =
+ACSRC = $(APPSACSRC)
 
 # C++ sources to be compiled in ARM mode regardless of the global setting.
 # NOTE: Mixing ARM and THUMB mode enables the -mthumb-interwork compiler
 #       option that results in lower performance and larger code size.
-ACPPSRC =
+ACPPSRC = $(APPSACPPSRC)
 
 # C sources to be compiled in THUMB mode regardless of the global setting.
 # NOTE: Mixing ARM and THUMB mode enables the -mthumb-interwork compiler
 #       option that results in lower performance and larger code size.
-TCSRC =
+TCSRC = $(APPSTCSRC)
 
 # C sources to be compiled in THUMB mode regardless of the global setting.
 # NOTE: Mixing ARM and THUMB mode enables the -mthumb-interwork compiler
 #       option that results in lower performance and larger code size.
-TCPPSRC =
+TCPPSRC = $(APPSTCPPSRC)
 
 # List ASM source files here
-ASMSRC =
+ASMSRC = $(APPSASMSRC)
 ASMXSRC = $(STARTUPASM) \
           $(PORTASM) \
-          $(OSALASM)
+          $(OSALASM) \
+          $(APPSASMXSRC)
 
 INCDIR = $(CHIBIOS)/os/license \
          $(STARTUPINC) \
diff --git a/os/modules/LightRing_1-0/Makefile b/os/modules/LightRing_1-0/Makefile
index 597e3c2..f178bf0 100644
--- a/os/modules/LightRing_1-0/Makefile
+++ b/os/modules/LightRing_1-0/Makefile
@@ -173,28 +173,29 @@ CPPSRC = $(AMIROOSCORECPPSRC) \
 # C sources to be compiled in ARM mode regardless of the global setting.
 # NOTE: Mixing ARM and THUMB mode enables the -mthumb-interwork compiler
 #       option that results in lower performance and larger code size.
-ACSRC =
+ACSRC = $(APPSACSRC)
 
 # C++ sources to be compiled in ARM mode regardless of the global setting.
 # NOTE: Mixing ARM and THUMB mode enables the -mthumb-interwork compiler
 #       option that results in lower performance and larger code size.
-ACPPSRC =
+ACPPSRC = $(APPSACPPSRC)
 
 # C sources to be compiled in THUMB mode regardless of the global setting.
 # NOTE: Mixing ARM and THUMB mode enables the -mthumb-interwork compiler
 #       option that results in lower performance and larger code size.
-TCSRC =
+TCSRC = $(APPSTCSRC)
 
 # C sources to be compiled in THUMB mode regardless of the global setting.
 # NOTE: Mixing ARM and THUMB mode enables the -mthumb-interwork compiler
 #       option that results in lower performance and larger code size.
-TCPPSRC =
+TCPPSRC = $(APPSTCPPSRC)
 
 # List ASM source files here
-ASMSRC =
+ASMSRC = $(APPSASMSRC)
 ASMXSRC = $(STARTUPASM) \
           $(PORTASM) \
-          $(OSALASM)
+          $(OSALASM) \
+          $(APPSASMXSRC)
 
 INCDIR = $(CHIBIOS)/os/license \
          $(STARTUPINC) \
diff --git a/os/modules/PowerManagement_1-1/Makefile b/os/modules/PowerManagement_1-1/Makefile
index bd9c31f..ebd5442 100644
--- a/os/modules/PowerManagement_1-1/Makefile
+++ b/os/modules/PowerManagement_1-1/Makefile
@@ -173,28 +173,29 @@ CPPSRC = $(AMIROOSCORECPPSRC) \
 # C sources to be compiled in ARM mode regardless of the global setting.
 # NOTE: Mixing ARM and THUMB mode enables the -mthumb-interwork compiler
 #       option that results in lower performance and larger code size.
-ACSRC =
+ACSRC = $(APPSACSRC)
 
 # C++ sources to be compiled in ARM mode regardless of the global setting.
 # NOTE: Mixing ARM and THUMB mode enables the -mthumb-interwork compiler
 #       option that results in lower performance and larger code size.
-ACPPSRC =
+ACPPSRC = $(APPSACPPSRC)
 
 # C sources to be compiled in THUMB mode regardless of the global setting.
 # NOTE: Mixing ARM and THUMB mode enables the -mthumb-interwork compiler
 #       option that results in lower performance and larger code size.
-TCSRC =
+TCSRC = $(APPSTCSRC)
 
 # C sources to be compiled in THUMB mode regardless of the global setting.
 # NOTE: Mixing ARM and THUMB mode enables the -mthumb-interwork compiler
 #       option that results in lower performance and larger code size.
-TCPPSRC =
+TCPPSRC = $(APPSTCPPSRC)
 
 # List ASM source files here
-ASMSRC =
+ASMSRC = $(APPSASMSRC)
 ASMXSRC = $(STARTUPASM) \
           $(PORTASM) \
-          $(OSALASM)
+          $(OSALASM) \
+          $(APPSASMXSRC)
 
 INCDIR = $(CHIBIOS)/os/license \
          $(STARTUPINC) \