commit f3ac1c962f9e3d7ff7d55141220df97c2b343ada
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Mon Feb 4 18:08:00 2019 +0100

    Applied a file structure template to all source files.

diff --git a/core/inc/aos_shell.h b/core/inc/aos_shell.h
index 6ba2f29..292870c 100644
--- a/core/inc/aos_shell.h
+++ b/core/inc/aos_shell.h
@@ -32,6 +32,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #include <hal.h>
 #include <aos_types.h>
 #include <aos_debug.h>
+/******************************************************************************/
+/* CONSTANTS                                                                  */
+/******************************************************************************/
 
 /**
  * @brief   Shell event flag that is emitted when the thread starts.
@@ -98,11 +101,17 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #define AOS_SHELLCHANNEL_OUTPUT_ENABLED           (1 << 2)
 
-/*
- * forward definitions
- */
-typedef struct aos_shellchannel AosShellChannel;
-typedef struct aos_shellstream AosShellStream;
+/******************************************************************************/
+/* SETTINGS                                                                   */
+/******************************************************************************/
+
+/******************************************************************************/
+/* CHECKS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* DATA STRUCTURES AND TYPES                                                  */
+/******************************************************************************/
 
 /**
  * @brief   AosShellChannel specific methods.
@@ -119,7 +128,7 @@ typedef struct aos_shellstream AosShellStream;
   /* event listener for the associated BaseAsynchronousChannel */           \
   event_listener_t listener;                                                \
   /* pointer to the next chennal in a AosShellStream */                     \
-  AosShellChannel* next;                                                    \
+  struct aos_shellchannel* next;                                            \
   /* flags related to the channel */                                        \
   uint8_t flags;
 
@@ -138,11 +147,11 @@ struct AosShellChannelVMT {
  * @brief   Shell channel class.
  * @details This class implements an asynchronous I/O channel.
  */
-struct aos_shellchannel {
+typedef struct aos_shellchannel {
   /** @brief Virtual Methods Table. */
   const struct AosShellChannelVMT* vmt;
   _aos_shell_channel_data
-};
+} AosShellChannel;
 
 /**
  * @brief   AosShellStream methods.
@@ -173,10 +182,10 @@ struct AosShellStreamVMT {
  * @details This class implements an base sequential stream.
  * @todo    So far only output but no input is supported.
  */
-struct aos_shellstream {
+typedef struct aos_shellstream {
   const struct AosShellStreamVMT* vmt;
   _aos_shellstream_data
-};
+} AosShellStream;
 
 /**
  * @brief   Shell command calback type.
@@ -351,6 +360,14 @@ typedef struct aos_shell {
   uint8_t config;
 } aos_shell_t;
 
+/******************************************************************************/
+/* MACROS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXTERN DECLARATIONS                                                        */
+/******************************************************************************/
+
 #ifdef __cplusplus
 extern "C" {
 #endif
@@ -371,6 +388,10 @@ extern "C" {
 }
 #endif
 
+/******************************************************************************/
+/* INLINE FUNCTIONS                                                           */
+/******************************************************************************/
+
 #endif /* (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) */
 
 #endif /* AMIROOS_SHELL_H */